Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12928)
@@ -1908,71 +1813,55 @@
 
       mld_prof(:,:) = 4
-      DO jk = 5, jpkm1
-        DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-            IF ( hmle(ji,jj) >= gdepw_n(ji,jj,jk) ) mld_prof(ji,jj) = MIN(mbkt(ji,jj), jk)
-          END DO
-        END DO
-      END DO
-      ! DO jj = 2, jpjm1
-      !    DO ji = 1, jpim1
-      !       zhmle(ji,jj) = gdepw_n(ji,jj,mld_prof(ji,jj))
-      !    END DO
-      !  END DO
+      DO_3D_00_00( 5, jpkm1 )
+         IF ( hmle(ji,jj) >= gdepw(ji,jj,jk, Kmm ) ) mld_prof(ji,jj) = MIN(mbkt(ji,jj), jk)
+      END_3D
+      ! DO_2D_00_10
+      !    zhmle(ji,jj) = gdepw(ji,jj,mld_prof(ji,jj), Kmm )
+      !  END_2D
    ! Timestep mixed layer eddy depth.
-      DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-          zdb_mle = grav * (rhop(ji,jj,mld_prof(ji,jj)) - rhop(ji,jj,ibld(ji,jj) )) * r1_rau0 ! check ALMG
-          IF ( lconv(ji,jj) .and. ( zdb_bl(ji,jj) < rn_osm_mle_thresh .and. mld_prof(ji,jj) > ibld(ji,jj) .and. zdb_mle > 0.0 ) ) THEN
-             hmle(ji,jj) = hmle(ji,jj) + zwb0(ji,jj) * rn_rdt / MAX( zdb_mle, rn_osm_mle_thresh )  ! MLE layer deepening through encroachment. Don't have a good maximum value for deepening, so use threshold buoyancy.
+      DO_2D_00_00
+       zdb_mle = grav * (rhop(ji,jj,mld_prof(ji,jj)) - rhop(ji,jj,ibld(ji,jj) )) * r1_rho0 ! check ALMG
+       IF ( lconv(ji,jj) .and. ( zdb_bl(ji,jj) < rn_osm_mle_thresh .and. mld_prof(ji,jj) > ibld(ji,jj) .and. zdb_mle > 0.0 ) ) THEN
+          hmle(ji,jj) = hmle(ji,jj) + zwb0(ji,jj) * rn_Dt / MAX( zdb_mle, rn_osm_mle_thresh )  ! MLE layer deepening through encroachment. Don't have a good maximum value for deepening, so use threshold buoyancy.
+       ELSE
+         ! MLE layer relaxes towards mixed layer depth on timescale tau_mle, or tau_mle/10
+          ! IF ( hmle(ji,jj) > zmld(ji,jj) ) THEN
+          !   hmle(ji,jj) = hmle(ji,jj) - ( hmle(ji,jj) - zmld(ji,jj) ) * rn_Dt / rn_osm_mle_tau
+          ! ELSE
+          !   hmle(ji,jj) = hmle(ji,jj) - 10.0 * ( hmle(ji,jj) - zmld(ji,jj) ) * rn_Dt / rn_osm_mle_tau ! fast relaxation if MLE layer shallower than MLD
+          ! ENDIF
+          IF ( hmle(ji,jj) > hbl(ji,jj) ) THEN
+            hmle(ji,jj) = hmle(ji,jj) - ( hmle(ji,jj) - hbl(ji,jj) ) * rn_Dt / rn_osm_mle_tau
           ELSE
-            ! MLE layer relaxes towards mixed layer depth on timescale tau_mle, or tau_mle/10
-             ! IF ( hmle(ji,jj) > zmld(ji,jj) ) THEN
-             !   hmle(ji,jj) = hmle(ji,jj) - ( hmle(ji,jj) - zmld(ji,jj) ) * rn_rdt / rn_osm_mle_tau
-             ! ELSE
-             !   hmle(ji,jj) = hmle(ji,jj) - 10.0 * ( hmle(ji,jj) - zmld(ji,jj) ) * rn_rdt / rn_osm_mle_tau ! fast relaxation if MLE layer shallower than MLD
-             ! ENDIF
-             IF ( hmle(ji,jj) > hbl(ji,jj) ) THEN
-               hmle(ji,jj) = hmle(ji,jj) - ( hmle(ji,jj) - hbl(ji,jj) ) * rn_rdt / rn_osm_mle_tau
-             ELSE
-               hmle(ji,jj) = hmle(ji,jj) - 10.0 * ( hmle(ji,jj) - hbl(ji,jj) ) * rn_rdt / rn_osm_mle_tau ! fast relaxation if MLE layer shallower than MLD
-             ENDIF
+            hmle(ji,jj) = hmle(ji,jj) - 10.0 * ( hmle(ji,jj) - hbl(ji,jj) ) * rn_Dt / rn_osm_mle_tau ! fast relaxation if MLE layer shallower than MLD
           ENDIF
-          hmle(ji,jj) = MIN(hmle(ji,jj), ht_n(ji,jj))
-        END DO
-      END DO
+       ENDIF
+       hmle(ji,jj) = MIN(hmle(ji,jj), ht(ji,jj))
+      END_2D
 
       mld_prof = 4
-      DO jk = 5, jpkm1
-        DO jj = 2, jpjm1
-          DO ji = 2, jpim1
-            IF ( hmle(ji,jj) >= gdepw_n(ji,jj,jk) ) mld_prof(ji,jj) = MIN(mbkt(ji,jj), jk)
-          END DO
-        END DO
-      END DO
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
-            zhmle(ji,jj) = gdepw_n(ji,jj, mld_prof(ji,jj))
-         END DO
-       END DO
+      DO_3D_00_00( 5, jpkm1 )
+        IF ( hmle(ji,jj) >= gdepw(ji,jj,jk, Kmm ) ) mld_prof(ji,jj) = MIN(mbkt(ji,jj), jk)
+      END_3D
+      DO_2D_00_00
+         zhmle(ji,jj) = gdepw(ji,jj, mld_prof(ji,jj), Kmm )
+      END_2D
    ! Calculate vertical buoyancy, heat and salinity fluxes due to MLE.
 
-      DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-          IF ( lconv(ji,jj) ) THEN
-             ztmp =  r1_ft(ji,jj) *  MIN( 111.e3_wp , e1u(ji,jj) ) / rn_osm_mle_lf
-             ! zwt_fk(ji,jj) = 0.5_wp * ztmp * ( dbdx_mle(ji,jj) * zdtdx(ji,jj) + dbdy_mle(ji,jj) * zdtdy(ji,jj) &
-             !      & + dbdx_mle(ji-1,jj) * zdtdx(ji-1,jj) + dbdy_mle(ji,jj-1) * zdtdy(ji,jj-1) )
-             ! zws_fk(ji,jj) = 0.5_wp * ztmp * ( dbdx_mle(ji,jj) * zdsdx(ji,jj) + dbdy_mle(ji,jj) * zdsdy(ji,jj) &
-             !      & + dbdx_mle(ji-1,jj) * zdsdx(ji-1,jj) + dbdy_mle(ji,jj-1) * zdsdy(ji,jj-1) )
-             zdbds_mle = SQRT( 0.5_wp * ( dbdx_mle(ji,jj) * dbdx_mle(ji,jj) + dbdy_mle(ji,jj) * dbdy_mle(ji,jj) &
-                  & + dbdx_mle(ji-1,jj) * dbdx_mle(ji-1,jj) + dbdy_mle(ji,jj-1) * dbdy_mle(ji,jj-1) ) )
-             zwb_fk(ji,jj) = rn_osm_mle_ce * hmle(ji,jj) * hmle(ji,jj) *ztmp * zdbds_mle * zdbds_mle
-      ! This vbelocity scale, defined in Fox-Kemper et al (2008), is needed for calculating dhdt.
-             zvel_mle(ji,jj) = zdbds_mle * ztmp * hmle(ji,jj) * tmask(ji,jj,1) 
-             zdiff_mle(ji,jj) = 1.e-4_wp * ztmp * zdbds_mle * zhmle(ji,jj)**3  / rn_osm_mle_lf
-          ENDIF
-        END DO
-      END DO
+      DO_2D_00_00
+        IF ( lconv(ji,jj) ) THEN
+           ztmp =  r1_ft(ji,jj) *  MIN( 111.e3_wp , e1u(ji,jj) ) / rn_osm_mle_lf
+           ! zwt_fk(ji,jj) = 0.5_wp * ztmp * ( dbdx_mle(ji,jj) * zdtdx(ji,jj) + dbdy_mle(ji,jj) * zdtdy(ji,jj) &
+           !      & + dbdx_mle(ji-1,jj) * zdtdx(ji-1,jj) + dbdy_mle(ji,jj-1) * zdtdy(ji,jj-1) )
+           ! zws_fk(ji,jj) = 0.5_wp * ztmp * ( dbdx_mle(ji,jj) * zdsdx(ji,jj) + dbdy_mle(ji,jj) * zdsdy(ji,jj) &
+           !      & + dbdx_mle(ji-1,jj) * zdsdx(ji-1,jj) + dbdy_mle(ji,jj-1) * zdsdy(ji,jj-1) )
+           zdbds_mle = SQRT( 0.5_wp * ( dbdx_mle(ji,jj) * dbdx_mle(ji,jj) + dbdy_mle(ji,jj) * dbdy_mle(ji,jj) &
+                & + dbdx_mle(ji-1,jj) * dbdx_mle(ji-1,jj) + dbdy_mle(ji,jj-1) * dbdy_mle(ji,jj-1) ) )
+           zwb_fk(ji,jj) = rn_osm_mle_ce * hmle(ji,jj) * hmle(ji,jj) *ztmp * zdbds_mle * zdbds_mle
+    ! This vbelocity scale, defined in Fox-Kemper et al (2008), is needed for calculating dhdt.
+           zvel_mle(ji,jj) = zdbds_mle * ztmp * hmle(ji,jj) * tmask(ji,jj,1) 
+           zdiff_mle(ji,jj) = 1.e-4_wp * ztmp * zdbds_mle * zhmle(ji,jj)**3  / rn_osm_mle_lf
+        ENDIF
+      END_2D
 END SUBROUTINE zdf_osm_mle_parameters
 
@@ -1980,5 +1869,5 @@
 
 
-   SUBROUTINE zdf_osm_init
+   SUBROUTINE zdf_osm_init( Kmm ) 
      !!----------------------------------------------------------------------
      !!                  ***  ROUTINE zdf_osm_init  ***
@@ -1992,4 +1881,6 @@
      !! ** input   :   Namlist namosm
      !!----------------------------------------------------------------------
+     INTEGER, INTENT(in)    :: Kmm ! time level index (middle)
+     !
      INTEGER  ::   ios            ! local integer
      INTEGER  ::   ji, jj, jk     ! dummy loop indices
@@ -2006,9 +1897,7 @@
      !!----------------------------------------------------------------------
      !
-     REWIND( numnam_ref )              ! Namelist namzdf_osm in reference namelist : Osmosis ML model
      READ  ( numnam_ref, namzdf_osm, IOSTAT = ios, ERR = 901)
 901  IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzdf_osm in reference namelist' )
 
-     REWIND( numnam_cfg )              ! Namelist namzdf_tke in configuration namelist : Turbulent Kinetic Energy
      READ  ( numnam_cfg, namzdf_osm, IOSTAT = ios, ERR = 902 )
 902  IF( ios >  0 ) CALL ctl_nam ( ios , 'namzdf_osm in configuration namelist' )
@@ -2049,9 +1938,9 @@
      IF( ln_osm_mle ) THEN
 ! Initialise Fox-Kemper parametrization
-         REWIND( numnam_ref )              ! Namelist namosm_mle in reference namelist : Tracer advection scheme
+         ! Namelist namosm_mle in reference namelist : Tracer advection scheme
          READ  ( numnam_ref, namosm_mle, IOSTAT = ios, ERR = 903)
 903      IF( ios /= 0 )   CALL ctl_nam ( ios , 'namosm_mle in reference namelist')
 
-         REWIND( numnam_cfg )              ! Namelist namosm_mle in configuration namelist : Tracer advection scheme
+         ! Namelist namosm_mle in configuration namelist : Tracer advection scheme
          READ  ( numnam_cfg, namosm_mle, IOSTAT = ios, ERR = 904 )
 904      IF( ios >  0 )   CALL ctl_nam ( ios , 'namosm_mle in configuration namelist')
@@ -2087,5 +1976,5 @@
       IF( ln_osm_mle ) THEN                ! MLE initialisation
          !
-         rb_c = grav * rn_osm_mle_rho_c /rau0        ! Mixed Layer buoyancy criteria
+         rb_c = grav * rn_osm_mle_rho_c /rho0        ! Mixed Layer buoyancy criteria
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) '      ML buoyancy criteria = ', rb_c, ' m/s2 '
@@ -2110,5 +1999,5 @@
       ENDIF
 
-     call osm_rst( nit000, 'READ' ) !* read or initialize hbl, dh, hmle
+     call osm_rst( nit000, Kmm, 'READ' ) !* read or initialize hbl, dh, hmle
 
 
@@ -2147,13 +2036,9 @@
         etmean(:,:,:) = 0.e0
 
-        DO jk = 1, jpkm1
-           DO jj = 2, jpjm1
-              DO ji = 2, jpim1   ! vector opt.
-                 etmean(ji,jj,jk) = tmask(ji,jj,jk)                     &
-                      &  / MAX( 1.,  umask(ji-1,jj  ,jk) + umask(ji,jj,jk)   &
-                      &            + vmask(ji  ,jj-1,jk) + vmask(ji,jj,jk)  )
-              END DO
-           END DO
-        END DO
+        DO_3D_00_00( 1, jpkm1 )
+           etmean(ji,jj,jk) = tmask(ji,jj,jk)                     &
+                &  / MAX( 1.,  umask(ji-1,jj  ,jk) + umask(ji,jj,jk)   &
+                &            + vmask(ji  ,jj-1,jk) + vmask(ji,jj,jk)  )
+        END_3D
 
      CASE ( 1 )                ! horizontal average
@@ -2165,16 +2050,12 @@
         etmean(:,:,:) = 0.e0
 
-        DO jk = 1, jpkm1
-           DO jj = 2, jpjm1
-              DO ji = 2, jpim1   ! vector opt.
-                 etmean(ji,jj,jk) = tmask(ji, jj,jk)                           &
-                      & / MAX( 1., 2.* tmask(ji,jj,jk)                           &
-                      &      +.5 * ( tmask(ji-1,jj+1,jk) + tmask(ji-1,jj-1,jk)   &
-                      &             +tmask(ji+1,jj+1,jk) + tmask(ji+1,jj-1,jk) ) &
-                      &      +1. * ( tmask(ji-1,jj  ,jk) + tmask(ji  ,jj+1,jk)   &
-                      &             +tmask(ji  ,jj-1,jk) + tmask(ji+1,jj  ,jk) ) )
-              END DO
-           END DO
-        END DO
+        DO_3D_00_00( 1, jpkm1 )
+           etmean(ji,jj,jk) = tmask(ji, jj,jk)                           &
+                & / MAX( 1., 2.* tmask(ji,jj,jk)                           &
+                &      +.5 * ( tmask(ji-1,jj+1,jk) + tmask(ji-1,jj-1,jk)   &
+                &             +tmask(ji+1,jj+1,jk) + tmask(ji+1,jj-1,jk) ) &
+                &      +1. * ( tmask(ji-1,jj  ,jk) + tmask(ji  ,jj+1,jk)   &
+                &             +tmask(ji  ,jj-1,jk) + tmask(ji+1,jj  ,jk) ) )
+        END_3D
 
      CASE DEFAULT
@@ -2208,5 +2089,5 @@
 
 
-   SUBROUTINE osm_rst( kt, cdrw )
+   SUBROUTINE osm_rst( kt, Kmm, cdrw )
      !!---------------------------------------------------------------------
      !!                   ***  ROUTINE osm_rst  ***
@@ -2218,5 +2099,6 @@
      !!----------------------------------------------------------------------
 
-     INTEGER, INTENT(in) :: kt
+     INTEGER         , INTENT(in) ::   kt     ! ocean time step index
+     INTEGER         , INTENT(in) ::   Kmm    ! ocean time level index (middle)
      CHARACTER(len=*), INTENT(in) ::   cdrw   ! "READ"/"WRITE" flag
 
@@ -2236,9 +2118,9 @@
         id1 = iom_varid( numror, 'wn'   , ldstop = .FALSE. )
         IF( id1 > 0 ) THEN                       ! 'wn' exists; read
-           CALL iom_get( numror, jpdom_autoglo, 'wn', wn, ldxios = lrxios )
-           WRITE(numout,*) ' ===>>>> :  wn read from restart file'
+           CALL iom_get( numror, jpdom_autoglo, 'wn', ww, ldxios = lrxios )
+           WRITE(numout,*) ' ===>>>> :  ww read from restart file'
         ELSE
-           wn(:,:,:) = 0._wp
-           WRITE(numout,*) ' ===>>>> :  wn not in restart file, set to zero initially'
+           ww(:,:,:) = 0._wp
+           WRITE(numout,*) ' ===>>>> :  ww not in restart file, set to zero initially'
         END IF
 
@@ -2270,5 +2152,5 @@
      IF( TRIM(cdrw) == 'WRITE') THEN     !* Write hbli into the restart file, then return
         IF(lwp) WRITE(numout,*) '---- osm-rst ----'
-         CALL iom_rstput( kt, nitrst, numrow, 'wn'     , wn,   ldxios = lwxios )
+         CALL iom_rstput( kt, nitrst, numrow, 'wn'     , ww  , ldxios = lwxios )
          CALL iom_rstput( kt, nitrst, numrow, 'hbl'    , hbl,  ldxios = lwxios )
          CALL iom_rstput( kt, nitrst, numrow, 'dh'     , dh,   ldxios = lwxios )
@@ -2284,28 +2166,22 @@
      IF( lwp ) WRITE(numout,*) ' ===>>>> : calculating hbl computed from stratification'
      ! w-level of the mixing and mixed layers
-     CALL eos_rab( tsn, rab_n )
-     CALL bn2(tsn, rab_n, rn2)
+     CALL eos_rab( ts(:,:,:,:,Kmm), rab_n, Kmm )
+     CALL bn2(ts(:,:,:,:,Kmm), rab_n, rn2, Kmm)
      imld_rst(:,:)  = nlb10         ! Initialization to the number of w ocean point
      hbl(:,:)  = 0._wp              ! here hbl used as a dummy variable, integrating vertically N^2
-     zN2_c = grav * rho_c * r1_rau0 ! convert density criteria into N^2 criteria
+     zN2_c = grav * rho_c * r1_rho0 ! convert density criteria into N^2 criteria
      !
      hbl(:,:)  = 0._wp              ! here hbl used as a dummy variable, integrating vertically N^2
-     DO jk = 1, jpkm1
-        DO jj = 1, jpj              ! Mixed layer level: w-level
-           DO ji = 1, jpi
-              ikt = mbkt(ji,jj)
-              hbl(ji,jj) = hbl(ji,jj) + MAX( rn2(ji,jj,jk) , 0._wp ) * e3w_n(ji,jj,jk)
-              IF( hbl(ji,jj) < zN2_c )   imld_rst(ji,jj) = MIN( jk , ikt ) + 1   ! Mixed layer level
-           END DO
-        END DO
-     END DO
+     DO_3D_11_11( 1, jpkm1 )
+        ikt = mbkt(ji,jj)
+        hbl(ji,jj) = hbl(ji,jj) + MAX( rn2(ji,jj,jk) , 0._wp ) * e3w(ji,jj,jk,Kmm)
+        IF( hbl(ji,jj) < zN2_c )   imld_rst(ji,jj) = MIN( jk , ikt ) + 1   ! Mixed layer level
+     END_3D
      !
-     DO jj = 1, jpj
-        DO ji = 1, jpi
-           iiki = MAX(4,imld_rst(ji,jj))
-           hbl (ji,jj) = gdepw_n(ji,jj,iiki  )    ! Turbocline depth
-           dh (ji,jj) = e3t_n(ji,jj,iiki-1  )     ! Turbocline depth
-        END DO
-     END DO
+     DO_2D_11_11
+        iiki = MAX(4,imld_rst(ji,jj))
+        hbl (ji,jj) = gdepw(ji,jj,iiki, Kmm )    ! Turbocline depth
+        dh (ji,jj) = e3t(ji,jj,iiki-1,  Kmm )    ! Turbocline depth
+     END_2D
 
      WRITE(numout,*) ' ===>>>> : hbl computed from stratification'
@@ -2316,10 +2192,10 @@
      END IF
 
-     wn(:,:,:) = 0._wp
+     ww(:,:,:) = 0._wp
      WRITE(numout,*) ' ===>>>> :  wn not in restart file, set to zero initially'
    END SUBROUTINE osm_rst
 
 
-   SUBROUTINE tra_osm( kt )
+   SUBROUTINE tra_osm( kt, Kmm, pts, Krhs )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_osm  ***
@@ -2331,5 +2207,8 @@
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt, ztrds   ! 3D workspace
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) :: kt
+      INTEGER                                  , INTENT(in)    :: kt        ! time step index
+      INTEGER                                  , INTENT(in)    :: Kmm, Krhs ! time level indices
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts,jpt), INTENT(inout) :: pts       ! active tracers and RHS of tracer equation
+      !
       INTEGER :: ji, jj, jk
       !
@@ -2341,34 +2220,29 @@
 
       IF( l_trdtra )   THEN                    !* Save ta and sa trends
-         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
-         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = pts(:,:,:,jp_tem,Krhs)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = pts(:,:,:,jp_sal,Krhs)
       ENDIF
 
-      DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-               tsa(ji,jj,jk,jp_tem) =  tsa(ji,jj,jk,jp_tem)                      &
-                  &                 - (  ghamt(ji,jj,jk  )  &
-                  &                    - ghamt(ji,jj,jk+1) ) /e3t_n(ji,jj,jk)
-               tsa(ji,jj,jk,jp_sal) =  tsa(ji,jj,jk,jp_sal)                      &
-                  &                 - (  ghams(ji,jj,jk  )  &
-                  &                    - ghams(ji,jj,jk+1) ) / e3t_n(ji,jj,jk)
-            END DO
-         END DO
-      END DO
+      DO_3D_00_00( 1, jpkm1 )
+         pts(ji,jj,jk,jp_tem,Krhs) =  pts(ji,jj,jk,jp_tem,Krhs)                      &
+            &                 - (  ghamt(ji,jj,jk  )  &
+            &                    - ghamt(ji,jj,jk+1) ) /e3t(ji,jj,jk,Kmm)
+         pts(ji,jj,jk,jp_sal,Krhs) =  pts(ji,jj,jk,jp_sal,Krhs)                      &
+            &                 - (  ghams(ji,jj,jk  )  &
+            &                    - ghams(ji,jj,jk+1) ) / e3t(ji,jj,jk,Kmm)
+      END_3D
 
       ! save the non-local tracer flux trends for diagnostics
       IF( l_trdtra )   THEN
-         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
-         ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
-
-         CALL trd_tra( kt, 'TRA', jp_tem, jptra_osm, ztrdt )
-         CALL trd_tra( kt, 'TRA', jp_sal, jptra_osm, ztrds )
+         ztrdt(:,:,:) = pts(:,:,:,jp_tem,Krhs) - ztrdt(:,:,:)
+         ztrds(:,:,:) = pts(:,:,:,jp_sal,Krhs) - ztrds(:,:,:)
+         CALL trd_tra( kt, Kmm, Krhs, 'TRA', jp_tem, jptra_osm, ztrdt )
+         CALL trd_tra( kt, Kmm, Krhs, 'TRA', jp_sal, jptra_osm, ztrds )
          DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds )
       ENDIF
 
-      IF(ln_ctl) THEN
-         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' osm  - Ta: ', mask1=tmask,   &
-         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(sn_cfctl%l_prtctl) THEN
+         CALL prt_ctl( tab3d_1=pts(:,:,:,jp_tem,Krhs), clinfo1=' osm  - Ta: ', mask1=tmask,   &
+         &             tab3d_2=pts(:,:,:,jp_sal,Krhs), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       ENDIF
       !
@@ -2393,5 +2267,5 @@
 
 
-   SUBROUTINE dyn_osm( kt )
+   SUBROUTINE dyn_osm( kt, Kmm, puu, pvv, Krhs )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dyn_osm  ***
@@ -2402,5 +2276,7 @@
       !! ** Method  :   ???
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   !
+      INTEGER                             , INTENT( in )  ::  kt          ! ocean time step index
+      INTEGER                             , INTENT( in )  ::  Kmm, Krhs   ! ocean time level indices
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpt), INTENT(inout) ::  puu, pvv    ! ocean velocities and RHS of momentum equation
       !
       INTEGER :: ji, jj, jk   ! dummy loop indices
@@ -2414,16 +2290,12 @@
       !code saving tracer trends removed, replace with trdmxl_oce
 
-      DO jk = 1, jpkm1           ! add non-local u and v fluxes
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-               ua(ji,jj,jk) =  ua(ji,jj,jk)                      &
-                  &                 - (  ghamu(ji,jj,jk  )  &
-                  &                    - ghamu(ji,jj,jk+1) ) / e3u_n(ji,jj,jk)
-               va(ji,jj,jk) =  va(ji,jj,jk)                      &
-                  &                 - (  ghamv(ji,jj,jk  )  &
-                  &                    - ghamv(ji,jj,jk+1) ) / e3v_n(ji,jj,jk)
-            END DO
-         END DO
-      END DO
+      DO_3D_00_00( 1, jpkm1 )
+         puu(ji,jj,jk,Krhs) =  puu(ji,jj,jk,Krhs)                      &
+            &                 - (  ghamu(ji,jj,jk  )  &
+            &                    - ghamu(ji,jj,jk+1) ) / e3u(ji,jj,jk,Kmm)
+         pvv(ji,jj,jk,Krhs) =  pvv(ji,jj,jk,Krhs)                      &
+            &                 - (  ghamv(ji,jj,jk  )  &
+            &                    - ghamv(ji,jj,jk+1) ) / e3v(ji,jj,jk,Kmm)
+      END_3D
       !
       ! code for saving tracer trends removed
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfphy.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfphy.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfphy.F90	(revision 12928)
@@ -56,10 +56,10 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: zdfphy.F90 12178 2019-12-11 11:02:38Z agn $
+   !! $Id$
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE zdf_phy_init
+   SUBROUTINE zdf_phy_init( Kmm )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE zdf_phy_init  ***
@@ -70,4 +70,6 @@
       !!                set horizontal shape and vertical profile of background mixing coef.
       !!----------------------------------------------------------------------
+      INTEGER, INTENT(in)    :: Kmm ! time level index (middle)
+      !
       INTEGER ::   jk            ! dummy loop indices
       INTEGER ::   ioptio, ios   ! local integers
@@ -91,9 +93,7 @@
       !
       !                           !==  Namelist  ==!
-      REWIND( numnam_ref )              ! Namelist namzdf in reference namelist : Vertical mixing parameters
       READ  ( numnam_ref, namzdf, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namzdf in reference namelist' )
       !
-      REWIND( numnam_cfg )              ! Namelist namzdf in reference namelist : Vertical mixing parameters
       READ  ( numnam_cfg, namzdf, IOSTAT = ios, ERR = 902 )
 902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namzdf in configuration namelist' )
@@ -191,8 +191,8 @@
       ioptio = 0 
       IF( ln_zdfcst ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_CST   ;   ENDIF
-      IF( ln_zdfric ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_RIC   ;   CALL zdf_ric_init   ;   ENDIF
-      IF( ln_zdftke ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_TKE   ;   CALL zdf_tke_init   ;   ENDIF
-      IF( ln_zdfgls ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_GLS   ;   CALL zdf_gls_init   ;   ENDIF
-      IF( ln_zdfosm ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_OSM   ;   CALL zdf_osm_init   ;   ENDIF
+      IF( ln_zdfric ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_RIC   ;   CALL zdf_ric_init          ;   ENDIF
+      IF( ln_zdftke ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_TKE   ;   CALL zdf_tke_init( Kmm )   ;   ENDIF
+      IF( ln_zdfgls ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_GLS   ;   CALL zdf_gls_init          ;   ENDIF
+      IF( ln_zdfosm ) THEN   ;   ioptio = ioptio + 1   ;    nzdf_phy = np_OSM   ;   CALL zdf_osm_init( Kmm )   ;   ENDIF
       !
       IF( ioptio /= 1 )    CALL ctl_stop( 'zdf_phy_init: one and only one vertical diffusion option has to be defined ' )
@@ -219,5 +219,5 @@
 
 
-   SUBROUTINE zdf_phy( kt )
+   SUBROUTINE zdf_phy( kt, Kbb, Kmm, Krhs )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE zdf_phy  ***
@@ -231,5 +231,6 @@
       !!                bottom stress.....                               <<<<====verifier !
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      INTEGER, INTENT(in) ::   kt         ! ocean time-step index
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Krhs   ! ocean time level indices
       !
       INTEGER ::   ji, jj, jk   ! dummy loop indice
@@ -242,9 +243,9 @@
          !
          !                       !* bottom drag
-         CALL zdf_drg( kt, mbkt    , r_Cdmin_bot, r_Cdmax_bot,   &   ! <<== in 
+         CALL zdf_drg( kt, Kmm, mbkt , r_Cdmin_bot, r_Cdmax_bot,   &   ! <<== in 
             &              r_z0_bot,   r_ke0_bot,    rCd0_bot,   &
             &                                        rCdU_bot  )     ! ==>> out : bottom drag [m/s]
          IF( ln_isfcav ) THEN    !* top drag   (ocean cavities)
-            CALL zdf_drg( kt, mikt    , r_Cdmin_top, r_Cdmax_top,   &   ! <<== in 
+            CALL zdf_drg( kt, Kmm, mikt , r_Cdmin_top, r_Cdmax_top,   &   ! <<== in 
                &              r_z0_top,   r_ke0_top,    rCd0_top,   &
                &                                        rCdU_top  )     ! ==>> out : bottom drag [m/s]
@@ -255,12 +256,12 @@
       !
       IF( l_zdfsh2 )   &         !* shear production at w-points (energy conserving form)
-         CALL zdf_sh2( ub, vb, un, vn, avm_k,   &     ! <<== in
-            &                           zsh2    )     ! ==>> out : shear production
+         CALL zdf_sh2( Kbb, Kmm, avm_k,   &     ! <<== in
+            &                     zsh2    )     ! ==>> out : shear production
       !
       SELECT CASE ( nzdf_phy )                  !* Vertical eddy viscosity and diffusivity coefficients at w-points
-      CASE( np_RIC )   ;   CALL zdf_ric( kt, gdept_n, zsh2, avm_k, avt_k )    ! Richardson number dependent Kz
-      CASE( np_TKE )   ;   CALL zdf_tke( kt         , zsh2, avm_k, avt_k )    ! TKE closure scheme for Kz
-      CASE( np_GLS )   ;   CALL zdf_gls( kt         , zsh2, avm_k, avt_k )    ! GLS closure scheme for Kz
-      CASE( np_OSM )   ;   CALL zdf_osm( kt               , avm_k, avt_k )    ! OSMOSIS closure scheme for Kz
+      CASE( np_RIC )   ;   CALL zdf_ric( kt,      Kmm, zsh2, avm_k, avt_k )    ! Richardson number dependent Kz
+      CASE( np_TKE )   ;   CALL zdf_tke( kt, Kbb, Kmm, zsh2, avm_k, avt_k )    ! TKE closure scheme for Kz
+      CASE( np_GLS )   ;   CALL zdf_gls( kt, Kbb, Kmm, zsh2, avm_k, avt_k )    ! GLS closure scheme for Kz
+      CASE( np_OSM )   ;   CALL zdf_osm( kt, Kbb, Kmm, Krhs, avm_k, avt_k )    ! OSMOSIS closure scheme for Kz
 !     CASE( np_CST )                                  ! Constant Kz (reset avt, avm to the background value)
 !         ! avt_k and avm_k set one for all at initialisation phase
@@ -281,9 +282,9 @@
       ENDIF
       !
-      IF( ln_zdfevd )   CALL zdf_evd( kt, avm, avt )  !* convection: enhanced vertical eddy diffusivity
+      IF( ln_zdfevd )   CALL zdf_evd( kt, Kmm, Krhs, avm, avt )  !* convection: enhanced vertical eddy diffusivity
       !
       !                                         !* double diffusive mixing
       IF( ln_zdfddm ) THEN                            ! update avt and compute avs
-                        CALL zdf_ddm( kt, avm, avt, avs )
+                        CALL zdf_ddm( kt, Kmm,  avm, avt, avs )
       ELSE                                            ! same mixing on all tracers
          avs(2:jpim1,2:jpjm1,1:jpkm1) = avt(2:jpim1,2:jpjm1,1:jpkm1)
@@ -291,6 +292,6 @@
       !
       !                                         !* wave-induced mixing 
-      IF( ln_zdfswm )   CALL zdf_swm( kt, avm, avt, avs )   ! surface  wave (Qiao et al. 2004) 
-      IF( ln_zdfiwm )   CALL zdf_iwm( kt, avm, avt, avs )   ! internal wave (de Lavergne et al 2017)
+      IF( ln_zdfswm )   CALL zdf_swm( kt, Kmm, avm, avt, avs )   ! surface  wave (Qiao et al. 2004) 
+      IF( ln_zdfiwm )   CALL zdf_iwm( kt, Kmm, avm, avt, avs )   ! internal wave (de Lavergne et al 2017)
 
 #if defined key_agrif 
@@ -313,5 +314,5 @@
       ENDIF
       !
-      CALL zdf_mxl( kt )                        !* mixed layer depth, and level
+      CALL zdf_mxl( kt, Kmm )                        !* mixed layer depth, and level
       !
       IF( lrst_oce ) THEN                       !* write TKE, GLS or RIC fields in the restart file
@@ -319,5 +320,5 @@
          IF( ln_zdfgls )   CALL gls_rst( kt, 'WRITE' )
          IF( ln_zdfric )   CALL ric_rst( kt, 'WRITE' ) 
-         ! NB. OSMOSIS restart (osm_rst) will be called in step.F90 after wn has been updated
+         ! NB. OSMOSIS restart (osm_rst) will be called in step.F90 after ww has been updated
       ENDIF
       !
